Loading...
Searching...
No Matches
EST_Window Class Reference

`#include <include/sigpr/EST_Window.h>`

## Public Types

typedef EST_WindowFunc | Func
| A function which creates a window.

## Static Public Member Functions

Functions for making windows.
static void | make_window (EST_TBuffer< float > &window_vals, int size, const char *name, int window_centre)
static void | make_window (EST_FVector &window_vals, int size, const char *name, int window_centre)
static Func * | creator (const char *name, bool report_error=false)
| Return the creation function for the given window type.
Performing windowing on a section of speech.
static void | window_signal (const EST_Wave &sig, EST_WindowFunc *make_window, int start, int size, EST_TBuffer< float > &frame)
static void | window_signal (const EST_Wave &sig, EST_WindowFunc *make_window, int start, int size, EST_FVector &frame, int resize=0)
static void | window_signal (const EST_Wave &sig, const EST_String &window_name, int start, int size, EST_FVector &frame, int resize=0)
static void | window_signal (const EST_Wave &sig, EST_TBuffer< float > &window_vals, int start, int size, EST_FVector &frame, int resize=0)
Utility window functions.
static EST_String | description (const char *name)
| Return the description for a given window type.
static EST_String | options_supported (void)
| Return a paragraph describing the available windows.
static EST_String | options_short (void)
| Return a comma separated list of the available window types.

## Detailed Description

The EST_Window class provides functions for the creation and use of signal processing windows.

Signal processing algorithms often work by on small sections of the speech waveform known as {frames}. A full signal must first be divided into these frames before these algorithms can work. While it would be simple to just "cut out" the required frames from the waveforms, this is usually undesirable as large discontinuities can occur at the frame edges. Instead it is customary to cut out the frame by means of aem window} function, which tapers the signal in the frame so that it has high values in the middle and low or zero values near the frame edges. The \Ref{EST_Window} class provides a wrap around for such windowing operations.

There are several types of window function, including:

\begin{itemize}

\item {\bf Rectangular}, which is used to give a simple copy of the the values between the window limits.

[w_{n} = \left \begin{array}{ll} 1 & \mbox{$0 \leq n \leq N$} \ 0 & \mbox{otherwise} \end{array} \right. ]

\item {\bf Hanning}. The rectangular window can cause sharp discontinuities at window edges. The hanning window solves this by ensuring that the window edges taper to 0.

[w_{n} = \left \begin{array}{ll} 0.5 - 0.5 \cos(2\pi n / (N-1)) & \mbox{$0 \leq n \leq N$} \ 0 & \mbox{otherwise} \end{array} \right. ]

\item {\bf Hamming.} The hanning window causes considerable energy loss, which the hamming window attempts to rectify.

[w_{n} = \left \begin{array}{ll} 0.54 - 0.46 \cos(2\pi n / (N-1)) & \mbox{$0 \leq n \leq N$} \ 0 & \mbox{otherwise} \end{array} \right. ]

\end{itemize}

The particular choice of window depends on the application. For instance in most speech synthesis applications Hanning windows are the most suitable as they don't have time domain discontinuities. For analysis applications hamming windows are normally used.

For example code, see \Ref{Windowing}

Definition at line 116 of file EST_Window.h.

## Member Typedef Documentation

## Func

typedef EST_WindowFunc EST_Window::Func

A function which creates a window.

Definition at line 120 of file EST_Window.h.

## Member Function Documentation

## make_window() [1/2]

void EST_Window::make_window | ( | EST_TBuffer< float > & | window_vals,
|  | int | size,
|  | const char * | name,
|  | int | window_centre )

static

Make a Buffer of containing a window function of specified type. If window_centre < 0 (default -1), then a symmetric window is returned. For positive values of the window_centre argument, asymmetric windows are returned.

Definition at line 255 of file EST_Window.cc.

## make_window() [2/2]

void EST_Window::make_window | ( | EST_FVector & | window_vals,
|  | int | size,
|  | const char * | name,
|  | int | window_centre )

static

Make a EST_FVector containing a window function of specified type. If window_centre < 0 (default -1), then a symmetric window is returned. For positive values of the window_centre argument, asymmetric windows are returned.

Definition at line 263 of file EST_Window.cc.

## creator()

EST_Window::Func * EST_Window::creator | ( | const char * | name,
|  | bool | report_error = false )

static

Return the creation function for the given window type.

Definition at line 216 of file EST_Window.cc.

## window_signal() [1/4]

void EST_Window::window_signal | ( | const EST_Wave & | sig,
|  | EST_WindowFunc * | make_window,
|  | int | start,
|  | int | size,
|  | EST_TBuffer< float > & | frame )

static

Window the waveform {\tt sig} starting at point {\tt start} for a duration of {\tt size} samples. The windowing function required is given as a function pointer {\tt *make_window} which has already been created by a function such as \Ref{creator}. The output windowed frame is placed in the buffer {\tt frame} which will have been resized accordingly within the function.

Definition at line 275 of file EST_Window.cc.

## window_signal() [2/4]

void EST_Window::window_signal | ( | const EST_Wave & | sig,
|  | EST_WindowFunc * | make_window,
|  | int | start,
|  | int | size,
|  | EST_FVector & | frame,
|  | int | resize = 0 )

static

Window the waveform {\tt sig} starting at point {\tt start} for a duration of {\tt size} samples. The windowing function required is given as a function pointer {\tt *make_window} which has already been created by a function such as \Ref{creator}. The output windowed frame is placed in the EST_FVector {\tt frame}. By default, it is assumed that this is already the correct size (i.e. {\tt size} samples long), but if resizing is required the last argument should be set to 1.

Definition at line 314 of file EST_Window.cc.

## window_signal() [3/4]

void EST_Window::window_signal | ( | const EST_Wave & | sig,
|  | const EST_String & | window_name,
|  | int | start,
|  | int | size,
|  | EST_FVector & | frame,
|  | int | resize = 0 )

static

Window the waveform {\tt sig} starting at point {\tt start} for a duration of {\tt size} samples. The windowing function required is given as a string: this function will make a temporary window of this type. The output windowed frame is placed in the EST_FVector {\tt frame}. By default, it is assumed that this is already the correct size (i.e. {\tt size} samples long), but if resizing is required the last argument should be set to 1.

Definition at line 305 of file EST_Window.cc.

## window_signal() [4/4]

void EST_Window::window_signal | ( | const EST_Wave & | sig,
|  | EST_TBuffer< float > & | window_vals,
|  | int | start,
|  | int | size,
|  | EST_FVector & | frame,
|  | int | resize = 0 )

static

Window the waveform {\tt sig} starting at point {\tt start} for a duration of {\tt size} samples. The window shape required is given as an array of floats. The output windowed frame is placed in the EST_FVector {\tt frame}. By default, it is assumed that this is already the correct size (i.e. {\tt size} samples long), but if resizing is required the last argument should be set to 1.

Definition at line 329 of file EST_Window.cc.

## description()

EST_String EST_Window::description | ( | const char * | name | ) |

static

Return the description for a given window type.

Definition at line 230 of file EST_Window.cc.

## options_supported()

EST_String EST_Window::options_supported | ( | void |  | ) |

static

Return a paragraph describing the available windows.

Definition at line 381 of file EST_Window.cc.

## options_short()

EST_String EST_Window::options_short | ( | void |  | ) |

static

Return a comma separated list of the available window types.

Definition at line 395 of file EST_Window.cc.

The documentation for this class was generated from the following files:

- include/sigpr/EST_Window.h
- sigpr/EST_Window.cc